// DebugExDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DebugEx.h"
#include "DebugExDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDebugExDlg dialog

CDebugExDlg::CDebugExDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDebugExDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDebugExDlg)
	m_strData = _T("");
	m_strMemory = _T("");
	m_strOverwrite = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDebugExDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDebugExDlg)
	DDX_Text(pDX, ID_DEBUGEX_DLG_TXT_DATA, m_strData);
	DDX_Text(pDX, ID_DEBUGEX_DLG_TXT_MEMORY, m_strMemory);
	DDX_Text(pDX, ID_DEBUGEX_DLG_TXT_OVERWRITE, m_strOverwrite);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDebugExDlg, CDialog)
	//{{AFX_MSG_MAP(CDebugExDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(ID_DEBUGEX_DLG_BTN_MEMORY, OnDebugExDlgBtnMemory)
	ON_BN_CLICKED(ID_DEBUGEX_DLG_BTN_OVERWRITE, OnDebugExDlgBtnOverwrite)
	ON_BN_CLICKED(ID_DEBUGEX_DLG_BTN_DATA, OnDebugExDlgBtnData)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDebugExDlg message handlers

BOOL CDebugExDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	// DebugEx (start) //////////////////////////

	// INITIALIZE MEMBER VARS
	m_iCount = 0;							// button press count
	m_strData.Format("%d", m_iCount);

	m_iDelete = 0;							// memory deletion count
	m_strMemory.Format("%d", m_iDelete);

	m_iSize = 10;							// size of array
	m_strOverwrite.Format("%d", m_iSize);

	// UPDATE DLG WND: FALSE => init, TRUE => retrieve vals
	UpdateData(FALSE);

	// DebugEx (end) ////////////////////////////
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CDebugExDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDebugExDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDebugExDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CDebugExDlg::OnDebugExDlgBtnData() 
{
	// TODO: Add your control notification handler code here

	// DebugEx (start)
	
	// Increment the member variable and display its value
	m_iCount++;

	// Format member var
	m_strData.Format("%d", m_iCount);

	// Update dlg wnd: FALSE => init, TRUE => retrieve vals
	UpdateData(FALSE);

	// DebugEx (end)
}

void CDebugExDlg::OnDebugExDlgBtnMemory() 
{
	// TODO: Add your control notification handler code here
	
	// DebugEx (start)
	double *v = NULL;	// vector

	// Msg
	AfxMessageBox("\n CDebugExDlg::OnDebugExDlgBtnMemory()    \n", MB_OK, 0);

	// MEMORY NEW
	v = new double[m_iSize];

	// MEMORY DELETE
	if(m_iDelete == 0)
	{
		// No deletion, causing a memory leak.
	}
	else if(m_iDelete == 1)
	{
		// Delete once
		delete [] v;
	}
	else if(m_iDelete == 2)
	{
		// Delete twice, erroneously, causing a crash.
		delete [] v;
		delete [] v;
	}

	// DebugEx (end)
}

void CDebugExDlg::OnDebugExDlgBtnOverwrite() 
{
	// TODO: Add your control notification handler code here
	
	// DebugEx (start)
	int i;	
	double *v = NULL;

	// Msg
	AfxMessageBox("\n CDebugExDlg::OnDebugExDlgBtnOverwrite()\n", MB_OK, 0);

	// MEMORY NEW
	v = new double[m_iSize];

	// Overwrite end of array
	//for(i=0; i<(m_iSize+10); i++)
	for(i=0; i<m_iSize; i++)
	{
		v[i] = i;
	}

	PrintVector(v, m_iSize);

	// MEMORY DELETE
	delete [] v;

	// DebugEx (end)
}

void CDebugExDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	CDialog::OnCancel();
}

void CDebugExDlg::OnOK() 
{
	// TODO: Add extra validation here
	
	CDialog::OnOK();
}

void CDebugExDlg::PrintVector(double *v, int n)
{
	// DebugEx (start)
	int i;
	CString sMsg;
	CString sMsgTemp;

	// Format output
	sMsgTemp.Format("\n\n CDebugExDlg::PrintVector()    \n\n");
	sMsg += sMsgTemp;
	sMsgTemp.Format(" vector = [");
	sMsg += sMsgTemp;

	for(i=0; i<n; i++)
	{
		sMsgTemp.Format(" %lf", v[i]);
		sMsg += sMsgTemp;
	}

	sMsgTemp.Format("]    \n\n");
	sMsg += sMsgTemp;

	// Display vector
	AfxMessageBox(sMsg, MB_OK, 0);

	// DebugEx (end)
}
